import type { Server } from "./compose";
import { bufferedRequest, bufferedResponse } from "./core/bufferedServer";
import type { CoreRequest } from "./core/server";
import { jsonRequest, JSONRequest, jsonResponse, JSONResponse } from "./json";

export function endpoint<ReqData, RespData>(
  app: Server<JSONRequest<ReqData | undefined>, JSONResponse<RespData>>,
): Server<CoreRequest, void> {
  return bufferedResponse(bufferedRequest(jsonResponse(jsonRequest(app))));
}
